Loading...
Searching...
No Matches
Opm::EQUIL::EquilReg< Scalar > Class Template Reference

Aggregate information base of an equilibration region. More...

`#include <EquilibrationHelpers.hpp>`

## Public Types

using | CalcDissolution = Miscibility::RsFunction<Scalar>
| Type of dissolved gas-oil ratio calculator.
using | CalcEvaporation = Miscibility::RsFunction<Scalar>
| Type of vapourised oil-gas ratio calculator.
using | CalcWaterEvaporation = Miscibility::RsFunction<Scalar>
| Type of vapourised water-gas ratio calculator.

## Public Member Functions

| EquilReg (const EquilRecord &rec, std::shared_ptr< Miscibility::RsFunction< Scalar > > rs, std::shared_ptr< Miscibility::RsFunction< Scalar > > rv, std::shared_ptr< Miscibility::RsFunction< Scalar > > rvw, const TabulatedFunction &tempVdTable, const TabulatedFunction &saltVdTable, const int pvtIdx)
| Constructor.
Scalar | datum () const
| Datum depth in current region.
Scalar | pressure () const
| Pressure at datum depth in current region.
Scalar | zwoc () const
| Depth of water-oil contact.
Scalar | pcowWoc () const
| water-oil capillary pressure at water-oil contact.
Scalar | zgoc () const
| Depth of gas-oil contact.
Scalar | pcgoGoc () const
| Gas-oil capillary pressure at gas-oil contact.
int | equilibrationAccuracy () const
| Accuracy/strategy for initial fluid-in-place calculation.
const CalcDissolution & | dissolutionCalculator () const
| Retrieve dissolved gas-oil ratio calculator of current region.
const CalcEvaporation & | evaporationCalculator () const
| Retrieve vapourised oil-gas ratio calculator of current region.
const CalcWaterEvaporation & | waterEvaporationCalculator () const
| Retrieve vapourised water-gas ratio calculator of current region.
const TabulatedFunction & | saltVdTable () const
const TabulatedFunction & | tempVdTable () const
int | pvtIdx () const
| Retrieve pvtIdx of the region.

## Detailed Description

template<class Scalar>
class Opm::EQUIL::EquilReg< Scalar >

Aggregate information base of an equilibration region.

Provides inquiry methods for retrieving depths of contacs and pressure values as well as a means of calculating fluid densities, dissolved gas-oil ratio and vapourised oil-gas ratios.

Template Parameters

  DensCalc | Type that provides access to a phase density calculation facility. Must implement an operator() declared as `std::vector<double> operator()(const double press, const std::vector<double>& svol)` that calculates the phase densities of all phases in `svol` at fluid pressure `press`.

## Constructor & Destructor Documentation

## EquilReg()

template<class Scalar>

Opm::EQUIL::EquilReg< Scalar >::EquilReg | ( | const EquilRecord & | rec,
|  | std::shared_ptr< Miscibility::RsFunction< Scalar > > | rs,
|  | std::shared_ptr< Miscibility::RsFunction< Scalar > > | rv,
|  | std::shared_ptr< Miscibility::RsFunction< Scalar > > | rvw,
|  | const TabulatedFunction & | tempVdTable,
|  | const TabulatedFunction & | saltVdTable,
|  | const int | pvtIdx )

Constructor.

Parameters

  [in] | rec | Equilibration data of current region.
  [in] | rs | Calculator of dissolved gas-oil ratio.
  [in] | rv | Calculator of vapourised oil-gas ratio.
  [in] | rvw | Calculator of vapourised water-gas ratio.
  [in] | tempVdTable | Temperature-dependent viscosity table
  [in] | saltVdTable | Salinity-dependent viscosity table
  [in] | pvtIdx | The pvt region index

## Member Function Documentation

## equilibrationAccuracy()

template<class Scalar>

int Opm::EQUIL::EquilReg< Scalar >::equilibrationAccuracy | ( |  | ) | const

Accuracy/strategy for initial fluid-in-place calculation.

Returns
  zero (N=0) for centre-point method, negative (N<0) for the horizontal subdivision method with 2*(-N) intervals, and positive (N>0) for the tilted subdivision method with 2*N intervals.

## pcgoGoc()

template<class Scalar>

Scalar Opm::EQUIL::EquilReg< Scalar >::pcgoGoc | ( |  | ) | const

Gas-oil capillary pressure at gas-oil contact.

Returns
  P_g - P_o at GOC.

## pcowWoc()

template<class Scalar>

Scalar Opm::EQUIL::EquilReg< Scalar >::pcowWoc | ( |  | ) | const

water-oil capillary pressure at water-oil contact.

Returns
  P_o - P_w at WOC.

The documentation for this class was generated from the following files:

- opm/simulators/flow/equil/EquilibrationHelpers.hpp
- opm/simulators/flow/equil/EquilibrationHelpers_impl.hpp